package net.pricefx.common.apibuilder.chart;

import net.pricefx.common.api.chart.AggregationFormula;
import net.pricefx.common.apibuilder.BacklinkBuilder;
import net.pricefx.common.apibuilder.ObjectIdentity;

public class AggrFieldAxis<S extends ObjectIdentity> extends BacklinkBuilder<S> {

	public AggrFieldAxis(final S backLink, final String instanceId, final String classId) {
		super(instanceId, classId, backLink);
	}

	public AggrFieldAxis<S> withTotal() {
		addInvocation("withTotal");
		return this;
	}

	public AggrFieldAxis<S> withPerUnit() {
		addInvocation("withPerUnit");
		return this;
	}

    public AggrFieldAxis<S> withAverage() {
        addInvocation("withAverage");
        return this;
    }

	public AggrFieldAxis<S> withPercent() {
		addInvocation("withPercent");
		return this;
	}
	
	public AggrFieldAxis<S> withFormula() {
		addInvocation("withFormula");
		return this;
	}
	/**
	 * @param aggregationFunction   {@code String} representation of an {@link net.pricefx.common.api.chart.AggregationFormula} constant
	 */
	public final AggrFieldAxis<S> withAggregation(final String aggregationFunction) {
		addInvocation("withAggregation", aggregationFunction);
		return this;
	}
	
	public final AggrFieldAxis<S> withAggregation(final AggregationFormula aggregationFunction) {
		addInvocation("withAggregation", aggregationFunction.name());
		return this;
	}
	
	public Expression<AggrFieldAxis<S>> withExpression() { 
		String id = addInvocation("withExpression");
		return new Expression<>(this, id, "Expression");
	}

}